import numpy as np
np.random.seed(1337)  # for reproducibility

from keras.preprocessing import sequence
from keras.models import Sequential
from keras.layers.core import Dense, Dropout, Activation
from keras.layers.embeddings import Embedding
from keras.layers.recurrent import LSTM
from keras.datasets import imdb
from numpy.random import choice


def loadData(max_features,maxlen):
    (X_train, y_train), (X_test, y_test) = imdb.load_data(nb_words=max_features,
                                                     test_split=0.2)
    X_train = sequence.pad_sequences(X_train, maxlen=maxlen)
    X_test = sequence.pad_sequences(X_test, maxlen=maxlen)
    return (X_train, y_train), (X_test, y_test) 
    

def learnModel(nb_epoch,max_features,maxlen,X_train, y_train, X_test, y_test):
    model = Sequential()
    model.add(Embedding(max_features, 128, input_length=maxlen))
    model.add(LSTM(128)) 
    model.add(Dropout(0.5))
    model.add(Dense(1))
    model.add(Activation('sigmoid'))
    
    model.compile(loss='binary_crossentropy',
                  optimizer='adam',
                  class_mode="binary")
    model.fit(X_train,y_train, batch_size=batch_size, nb_epoch=3,
          validation_data=(X_test, y_test), show_accuracy=True)
    return model
    
def evaluate(model,X_test, y_test):
    score = model.evaluate(X_test, y_test, show_accuracy=True, verbose=0)
    return score

print("Train...")



max_features = 200
maxlen = 10  # cut texts after this number of words (among top max_features most common words)
batch_size = 32
nb_epoch=3
samplesize=500

